//ipodSoftModem
//f.olofsson 2011-06-12
//bugfix 2011-09-25: pwm counter should wrap at 128
//using frequency-shift keying.  combining 3 real pwm with 3 soft pwm

#include <SoftModem.h>    //SoftModem-004 by arms22

SoftModem modem;
byte pwm, pos, val;
byte data[]= {0, 0, 0, 0, 0, 0};

void setup() {
  modem.begin();
  pwm= 0;
  pos= 0;
  DDRB |= 1<<PB0;       //mega168 pin14
  DDRB |= 1<<PB3;       //mega168 pin17
  DDRB |= 1<<PB4;       //mega168 pin18
  
  //--startup blink
  for(byte i= 0; i<3; i++) {
    analogWrite(5, 127);
    analogWrite(9, 127);
    analogWrite(10, 127);
    PORTB |= 1<<PB0;
    PORTB |= 1<<PB3;
    PORTB |= 1<<PB4;
    delay(100);
    analogWrite(5, 0);
    analogWrite(9, 0);
    analogWrite(10, 0);
    PORTB &= ~(1<<PB0);
    PORTB &= ~(1<<PB3);
    PORTB &= ~(1<<PB4);
    delay(100);
  }
}
void loop () {
  if(modem.available()) {
    val= modem.read();
    if(val>=128) {
      pos= 0;
      val= val-128;
    }
    data[pos]= val;
    pos= (pos+1)%6;
  }
  analogWrite(5, data[0]);    //mega168 pin11
  analogWrite(9, data[1]);    //mega168 pin15
  analogWrite(10, data[2]);   //mega168 pin16
  if(pwm<data[3]) {
    PORTB |= 1<<PB0;
  } else {
    PORTB &= ~(1<<PB0);
  }
  if(pwm<data[4]) {
    PORTB |= 1<<PB3;
  } else {
    PORTB &= ~(1<<PB3);
  }
  if(pwm<data[5]) {
    PORTB |= 1<<PB4;
  } else {
    PORTB &= ~(1<<PB4);
  }
  pwm= (pwm+1)%128;
}

